{{
import datetime
import malcat

def pval(key, val=None, fmt="{}", pa=False, kalign=30, valign=0, formated=False):
    r = "[normal]{}[/normal]:".format(key)
    lr = len(r) - 17
    if lr < kalign:
        r += (" "*(kalign-lr))
    if isinstance(val, malcat.StructAccess):
        if val.has_enum and val.enum:
            d = "[color6]{}[/color6]([dim]{}[/dim])".format(val.enum, fmt.format(val.value))
            formated = True
            ld = len(d) - len("[color3][/color3][dim][/dim]")
        else:
            d = fmt.format(val.value)
            ld = len(d)
        val = val.value
    else:
        if type(val) == str:
            val = val.replace("\x00", "").replace("\[", "")
        d = fmt.format(val)
        ld = len(d)
    if not formated:
        grp = "normal"
        if type(val) == int: 
            if pa:
                grp = "fa"
            elif val == 0:
                grp = "dim"
            else:
                grp = "normal"
        elif isinstance(val, datetime.datetime):
            if val.year <= 1980:
                grp = "dim"
            d = val.strftime("%Y-%m-%d %H:%M")
            ld = len(d)
        d = "[{}]{}[/{}]".format(grp,d,grp)
    if ld < valign:
        d += (" "*(valign-ld))
    write(r+d)  

def bitfieldpp(fa):
    s = []
    for i in range(fa.count - 1, -1, -1):
        bit = fa.at(i)
        if bit.value:
            s.append("[color5]{}[/color5]([dim]{:X}[/dim])".format(bit.name, 1 << i))
    if s:
        return  " + ".join(s)
    else:
        return "[dim]0[/dim]"

def pbitfield(key, fa, kalign=30):    
    r = "[normal]{}[/normal]:".format(key)
    lr = len(r) - 17
    if lr < kalign:
        r += (" "*(kalign-lr))
    write(r + bitfieldpp(fa))

def pdecimaldatetime(fa):
    return  "{}-{}-{} {}:{}:{}".format(fa["Year"], fa["Month"], fa["Day"], fa["Hours"], fa["Minutes"], fa["Seconds"])

def pbinarydatetime(fa):
    return  "{:04d}-{:02d}-{:02d} {:02d}:{:02d}:{:02d}".format(fa["Year"] + 1900, fa["Month"], fa["Day"], fa["Hours"], fa["Minutes"], fa["Seconds"])

def nice(s):
    return s.replace("[", "\\[").replace("\x00", "")
}}
{{
pvd = analysis.struct["PrimaryVolumeDescriptor"]
num_files = len(analysis.parser.filesystem)
num_files_displayed = 0
}}

[color1]Volume[/color1]
  {{ pval("Volume name", pvd["VolumeIdentifier"]) }} 
  {{ pval("System identifier", pvd["SystemIdentifier"]) }} 
  {{ pval("Volume index", "{:d} / {:d}".format(pvd["VolumeSequenceNumber"]["Lsb"], pvd["VolumeSetSize"]["Lsb"]), valign=24) }} {{ pval("Block size", pvd["LogicalBlockSize"]["Lsb"]) }}
  {{ pval("Creation time", pdecimaldatetime(pvd["VolumeCreationTime"]), valign=24) }} {{ pval("Modification time", pdecimaldatetime(pvd["VolumeModificationTime"]), valign=24) }} 


[color1]Files[/color1]
{{for name, entry in analysis.parser.filesystem.items():}}
  [color2]{{write(nice(name))}}[/color2]
    {{ pval("Offset", entry["ExtentLocation"]["Lsb"]*2048, "{:x}", pa=True, kalign=28, valign=24) }} {{ pval("Size", entry["ExtentSize"]["Lsb"], "{} bytes") }}  
    {{ pval("Creation time", pbinarydatetime(entry["DateTime"]), kalign=28, valign=24) }}
    {{ pbitfield("Flags", entry["Flags"], kalign=28) }}
{{
if num_files_displayed > 128:
    write("[block1] ... and more ...[/block1]")
    break
num_files_displayed += 1
}}
{{:endfor}}
